; function ipow(x:double; y: word): double
; calculate x^y, with y being a positive integer by multiplying x
; y-times with itself
;
; written: 20.11.93
; last modification: 18/07/94 - change to 286/87 mode
;                    20/08/94 - change var type to double instead of extended

         .286
         .287
         noemul
code     segment use16
         assume cs: code

IPow     proc near
         public ipow

         mov bx,sp
         mov cx, word ptr ss:[bx+2]   ; y in cx
         fld1                         ; 1 in st(0)
         fld qword ptr ss:[bx+4]      ; x in st(0), 1 in (st(1)
         xor di, di                   ; cnt:= 0
iter:    inc di                       ; inc (cnt)
         fmul st(1), st               ; st(1):= st(1)*st(0)
         cmp di, cx                   ; cnt < y ?
         jl iter                      ; no -> next iteration
         fstp st(0)                   ; st(0):= st(0); pop -> result st(1)
                                      ; now in st(0); rest of stack is clear
         ret 10                       ; return 1*word + 1*double = 10bytes

IPow     endp
code     ends
         END
